#region Using directives

using System;
using System.Text;
using System.Drawing;

#endregion

namespace BitmapHandler
{
    public class BitmapHandler : IDisposable
    {
        private Bitmap bmp;
        private Random rnd;

       // constructor
        public BitmapHandler(Bitmap bm)
        {
            bmp = bm;
            rnd = new Random();
        }

        // public properties
        public Bitmap ControlRef
        { get { return bmp; } }



        public Bitmap Value
        { get { return bmp;}}


        // public methods

        public int timer(int[]x, int[]y, int[]col, int n, double spread)
        {
            int i;
            for(i = 0 ; i<n ; i++)
            {
                // this guards against out of range initial inputs
                // it's inefficient here and should be done at particle creation time
                x[i] = Math.Min(Math.Max(x[i],0),bmp.Width-1);
                y[i] = Math.Min(Math.Max(y[i],0),bmp.Height-1);
                // undraw old particle position
                bmp.SetPixel(x[i],y[i],Color.Black);
                // calculate next position
                x[i] = Math.Min(Math.Max(x[i] + (int)((2 * rnd.NextDouble() - 1) * spread),0),bmp.Width-1);
                y[i] = Math.Min(Math.Max(y[i] + 1,0),bmp.Height-1);
                // draw it or lose it off the bottom
                if ( y[i] < bmp.Height -1)
                {                    
                   bmp.SetPixel(x[i],y[i],Color.FromArgb( col[i]));  
                }
                else
                {
                    x[i]=x[n-1];
                    y[i]=y[n-1];
                    col[i] = col[n-1];
                    n=n-1;
                } 
            }
            return n;
        }

        public void Dispose()
        {
            bmp = null;
        }
    }


}
